<?xml version="1.0"?>

<queryset>
   <rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="get_survey_info.n_completed">
<querytext>
    		    select count(distinct survey_response.initial_user_id(response_id))
                    from 
		    survey_responses
		    where survey_id=:survey_id
</querytext>
</fullquery>

<fullquery name="survey_section_add_to_form.questions">
<querytext>
	select min(question_id) as question_id,
	dbms_lob.substr(question_text) as question_text from
	survey_questions where section_id=:section_id group by
	dbms_lob.substr(question_text) order by min(sort_order)
</querytext>
</fullquery>

<fullquery name="survey_section_add_to_form.question_details">
<querytext>
	select question_id, required_p
	from survey_questions where
	section_id=:section_id and
	0=dbms_lob.compare(question_text,(select question_text from
	survey_questions where question_id=:q_id))
</querytext>
</fullquery>


<fullquery name="survey_question_copy.create_question">      
      <querytext>
      
	    begin
		:1 := survey_question.new (
		    question_id => NULL,
		    section_id => :section_id,
                    sort_order => :new_sort_order,
                    question_text => empty_clob(),
                    abstract_data_type => :abstract_data_type,
                    presentation_type => :presentation_type,
                    presentation_alignment => :presentation_alignment,
		    presentation_options => :presentation_options,
                    active_p => :active_p,
                    required_p => :required_p,
		    context_id => :section_id,
		    creation_user => :user_id,
		    question_html_p => :question_html_p,
		    summary_type => :summary_type,
		    answer_description => :answer_description,
		    predefined_question_id => :predefined_question_id
		);
	    end;
	
      </querytext>
</fullquery>


<fullquery name="survey_copy.survey_create">
<querytext>
	    begin
	        :1 := survey.new (
                    survey_id => NULL,
                    name => :name,
                    description => :description,
                    description_html_p => :description_html_p,
	            editable_p => :editable_p,
                    single_response_p => :single_response_p,
                    enabled_p => :enabled_p,
                    single_section_p => :single_section_p,
                    type => :type,
                    display_type => :display_type,
                    package_id => :package_id,
                    context_id => :package_id,
		    creation_user => :user_id,
		    public_p => :public_p
                );
    end;
</querytext>
</fullquery>

<fullquery name="survey_copy.section_create">
<querytext>
	    begin
	    :1 := survey_section.new (
	              section_id=>NULL,
		      survey_id=>:new_survey_id,
		      name=>:name,
		      description=>empty_clob(),
		      description_html_p=>:description_html_p,
		      sort_key=>:sort_key,
		      branch_p=>:branch_p,
		      branched_p=>:branched_p,
		      block_section_p=>:block_section_p,
		      page_break_p=>:page_break_p,
		      context_id =>:new_survey_id	
		      );
	    end;
</querytext>
</fullquery>

<fullquery name="survey_do_notifications.get_response_info">
    <querytext>
        select r.initial_response_id, o.creation_user as responding_user_id, r.response_id,
            u.first_names || ' ' || u.last_name as user_name,
            edit_p,
            o.creation_date as response_date, o.creation_user as responding_user_id
            from (select nvl(initial_response_id,response_id) as initial_response_id,
                  response_id, (case when initial_response_id is NULL then 'f' else 't' end) as edit_p
            from survey_responses) r, acs_objects o,
            cc_users u where r.response_id=:response_id
            and o.creation_user = u.user_id(+)
            and r.response_id = o.object_id
    </querytext>
</fullquery>

<fullquery name="survey_next_sections.get_last_answered_section_sort_key">
    <querytext>
    select nvl(max(sort_key),0) from
    survey_sections s,survey_question_responses qr, survey_questions q where
    qr.response_id=:response_id and qr.question_id=q.question_id and
    s.section_id=q.section_id
    </querytext>
</fullquery>

<fullquery name="survey_export_csv.get_all_survey_question_responses">
<querytext>
select
    sq.response_id,
    sq.question_id,
    sq.email,
    sq.first_names,
    sq.last_name,
    sq.user_id,
    sq.creation_date,
    resp.boolean_answer,
    resp.number_answer,
    resp.date_answer,
    resp.varchar_answer,
    resp.clob_answer,
    resp.attachment_answer,
    resp.label
  from 
  (select
    sqr.response_id,
    sqr.question_id,
    sqr.boolean_answer,
    sqr.number_answer,
    sqr.date_answer,
    sqr.varchar_answer,
    sqr.clob_answer,
    sqr.attachment_answer,
    sqc.label,
    sqc.sort_order
  from
    survey_responses sr,
    survey_question_responses sqr,
    survey_question_choices sqc
  where
    sr.survey_id=:survey_id
    and sr.response_id = sqr.response_id
    and sqr.question_id = sqc.question_id (+)
    and sqr.choice_id = sqc.choice_id (+)) resp,
  (select r.response_id,
          q.question_id,
          u.email,
          u.first_names,
          u.last_name,
          r.user_id,
          r.creation_date,
          q.abstract_data_type,
          q.sort_order,
	  ss.sort_key
     from survey_questions q, (select initial_user_id as user_id, creation_date, response_id from survey_responses_latest rt where survey_id=:survey_id) r, cc_users u, survey_sections ss
     where ss.survey_id=:survey_id
     and q.section_id=ss.section_id
     and r.user_id = u.user_id) sq
  where sq.response_id = resp.response_id (+)
   and sq.question_id = resp.question_id (+)
  order by
    sq.response_id,
    sq.sort_key,
    sq.sort_order,
    sq.question_id,
    resp.sort_order
</querytext>
</fullquery>

<fullquery name="survey_export_csv.get_all_survey_question_responses_with_anonymous">
<querytext>
select
    sq.response_id,
    sq.question_id,
    sq.email,
    sq.first_names,
    sq.last_name,
    sq.user_id,
    sq.creation_date,
    resp.boolean_answer,
    resp.number_answer,
    resp.date_answer,
    resp.varchar_answer,
    resp.clob_answer,
    resp.attachment_answer,
    resp.label
  from 
  (select
    sqr.response_id,
    sqr.question_id,
    sqr.boolean_answer,
    sqr.number_answer,
    sqr.date_answer,
    sqr.varchar_answer,
    sqr.clob_answer,
    sqr.attachment_answer,
    sqc.label,
    sqc.sort_order
  from
    survey_responses sr,
    survey_question_responses sqr,
    survey_question_choices sqc
  where
    sr.survey_id=:survey_id
    and sr.response_id = sqr.response_id
    and sqr.question_id = sqc.question_id (+)
    and sqr.choice_id = sqc.choice_id (+)) resp,
  (select r.response_id,
          q.question_id,
          u.email,
          u.first_names,
          u.last_name,
          r.user_id,
          r.creation_date,
          q.abstract_data_type,
          q.sort_order,
	  ss.sort_key
     from survey_questions q, (select initial_user_id as user_id, creation_date, response_id from survey_responses_latest rt where survey_id=:survey_id) r, cc_users u, survey_sections ss
     where ss.survey_id=:survey_id
     and q.section_id=ss.section_id
     and r.user_id = u.user_id(+)) sq
  where sq.response_id = resp.response_id (+)
   and sq.question_id = resp.question_id (+)
  order by
    sq.response_id,
    sq.sort_key,
    sq.sort_order,
    sq.question_id,
    resp.sort_order
</querytext>
</fullquery>

</queryset>

