ad_page_contract {
    Present form to add a condition to an existing branch
} {
    section_id:integer,notnull
}

set package_id [ad_conn package_id]
set user_id [ad_get_user_id]
ad_require_permission $package_id admin

get_survey_info -section_id $section_id
set survey_id $survey_info(survey_id)
set context_bar [ad_context_bar [list "one?[export_url_vars survey_id]" $survey_info(name)] "Add A Section"]

db_1row branch_info ""

set condition_id [db_nextval survey_condition_id_sequence]

set options [list]
db_foreach questions "" {
    if {$abstract_data_type == "boolean"} {
	set choices [list [list "t" Yes] [list "f" No]]
    } else {
	set choices [db_list_of_lists choices ""]
    }
    set question "$question_text: "
    foreach choice $choices {
	set choice_id   [lindex $choice 0]
	set choicelabel [lindex $choice 1]
	lappend options [list "${question}$choicelabel" "${question_id}:${choice_id}"]
    }
}

if {[empty_string_p $options]} {
    ad_return_complaint 1 "No appropriate questions found"
    ad_script_abort
}

ad_form -name add_condition -action condition-add-2 -form {
    {condition_id:text(hidden) {value $condition_id}}
    {branch_id:text(hidden) {value $branch_id}}
    {section_id:text(hidden) {value $section_id}}
    {choice:text(radio) {label "Which choice should lead to this branch?"} {options $options}}
}


