ad_page_contract {
    Present form to begin adding a predefined question to a survey.

    @param section_id    integer designating survey we're adding question to
    @param after        optinal integer denoting position of question within survey

    @author  jsc@arsdigita.com
    @author  nstrug@arsdigita.com
    @date    February 9, 2000
    @cvs-id $Id: predefined-question.tcl,v 1.1 2003/09/19 16:48:04 rmello Exp $
} {
    section_id:integer
    {after:integer ""}
    
}

set package_id [ad_conn package_id]
set user_id [ad_get_user_id]
ad_require_permission $package_id admin

get_survey_info -section_id $section_id
get_section_info -section_id $section_id

if {$section_info(block_section_p)=="t"} {
    ad_returnredirect "block-question-add?[export_url_vars section_id after]"
    ad_script_abort
}

set predefs [db_list_of_lists predefined_questions ""]

set next_question_id [db_nextval acs_object_id_seq]

ad_form -name create_question -action predefined-question-2  -export { after } -form {
    {question_id:text(hidden) {value $next_question_id}}
    {section_id:text(hidden) {value $section_id}}
    {predefined_question_id:integer(select) {label "Question"} {options $predefs}}
    {question_text:text(textarea) {label "Question (leave empty to keep original)"}  {html {rows 5 cols 70}}}   
}	    
		
set survey_id $survey_info(survey_id)
set context_bar [ad_context_bar [list "one?[export_url_vars survey_id]" $survey_info(name)] "Add A Question"]

if {[ad_parameter allow_question_deactivation_p] == 1} {
    ad_form -extend -name create_question -form {
        {active:text(radio)     {label "Active?"} {options {{Yes t} {No f}}} {value t}}
    } 
} else {
    ad_form -extend -name create_question -form {
        {active:text(hidden) {value t}}
    }
}
ad_form -extend -name create_question -form {
    {required_p:text(radio)     {label "Required?"} {options {{Yes t} {No f}}} {value t}}
}
    
ad_return_template




