# /packages/survey/www/admin/public-toggle.tcl
ad_page_contract {

    Toggles a survey between public and non-public

    @param section_id survey whose properties we're changing

    @cvs-id 

} {

    survey_id:integer

}

ad_require_permission $survey_id admin

db_transaction {
    db_dml survey_public_toggle ""
    set public_id [acs_magic_object "the_public"]
    db_1row survey_public_p ""
    if {$public_p == "t"} {
	# switch to public_p
	permission::grant -party_id $public_id -object_id $survey_id -privilege write
    } else {
	# switch to not public_p
	permission::revoke -party_id $public_id -object_id $survey_id -privilege write
    }
}
    
db_release_unused_handles

ad_returnredirect "one?[export_url_vars survey_id]"
