ad_page_contract {

  Swaps two sort keys for a survey, sort_order and sort_order - 1.

  @param  section_id  survey we're acting upon
  @param  sort_order   integer determining position of question which is
                     about to be replaced with previous one

  @author nstrug@arsdigita.com

  @cvs-id $Id: question-swap.tcl,v 1.1 2003/09/19 16:48:04 rmello Exp $

} {
  survey_id:integer,notnull
  section_id:integer,notnull
  sort_order:integer,notnull
  direction:notnull
}

ad_require_permission $section_id admin

if { $direction=="up" } {
     set next_sort_order [expr { $sort_order - 1 }]
} else {
     set next_sort_order [expr { $sort_order + 1 }]
}
db_transaction {
    db_dml swap_sort_orders ""

} on_error {

    ad_return_error "Database error" "A database error occured while trying
to swap your questions. Here's the error:
<pre>
$errmsg
</pre>
"
    ad_script_abort
}
ad_returnredirect "one?survey_id=$survey_id&#${sort_order}"

