<?xml version="1.0"?>

<queryset>
   <rdbms><type>oracle</type><version>8.1.6</version></rdbms>

<fullquery name="get_all_survey_question_responses">
<querytext>
select    
    sub.response_id,
    sub.question_id,
    sub.email,
    sub.first_names,
    sub.last_name,
    sub.user_id,
    sub.creation_date,
    qr.boolean_answer,
    qr.number_answer,
    qr.date_answer,
    qr.varchar_answer,
    qr.clob_answer,
    qr.attachment_answer,
    qc.label
from 
(select 
    r.response_id,
    q.question_id,
    u.email,
    u.first_names,
    u.last_name,
    u.user_id,
    to_char(r.creation_date,'YYYY-MM-DD HH24:MI:SS') as creation_date,
    q.sort_order as q_sort_order
from survey_responses_latest r, cc_users u,survey_questions q, survey_sections s
     where
    s.survey_id=:survey_id
and r.survey_id=:survey_id
     and q.section_id=s.section_id
and r.initial_user_id=u.user_id) sub, survey_question_responses qr,
     survey_question_choices qc
where qr.question_id(+)=sub.question_id
and sub.response_id=qr.response_id(+)
     and qc.choice_id(+)=qr.choice_id
  order by
    sub.response_id,
    sub.q_sort_order,
    sub.question_id,
    qc.sort_order
</querytext>
</fullquery>

<fullquery name="get_all_survey_question_responses_anonymous">
<querytext>
select    
    sub.response_id,
    sub.question_id,
    sub.email,
    sub.first_names,
    sub.last_name,
    sub.user_id,
    sub.creation_date,
    qr.boolean_answer,
    qr.number_answer,
    qr.date_answer,
    qr.varchar_answer,
    qr.clob_answer,
    qr.attachment_answer,
    qc.label
from 
(select 
    r.response_id,
    q.question_id,
    u.email,
    nvl(u.first_names,'Unregistered') as first_names,
    nvl(u.last_name,'Visitor') as last_name,
    u.user_id,
    to_char(r.creation_date,'YYYY-MM-DD HH24:MI:SS') as creation_date,
    q.sort_order as q_sort_order
from survey_responses_latest r, cc_users u,survey_questions q, survey_sections s
     where
    s.survey_id=:survey_id
and r.survey_id=:survey_id
     and q.section_id=s.section_id
and nvl(r.initial_user_id,0)=u.user_id(+)) sub, survey_question_responses qr,
     survey_question_choices qc
where qr.question_id(+)=sub.question_id
and sub.response_id=qr.response_id(+)
     and qc.choice_id(+)=qr.choice_id
  order by
    sub.response_id,
    sub.q_sort_order,
    sub.question_id,
    qc.sort_order
</querytext>
</fullquery>

</queryset>
