# /packages/survey/www/admin/survey-sectioned-toggle.tcl
ad_page_contract {

    Toggles a survey between having only one or multiple sections

    @param section_id survey whose properties we're changing

    @cvs-id 

} {

    survey_id:integer

}

ad_require_permission $survey_id admin

db_transaction {
    get_survey_info -survey_id $survey_id
    ns_log notice "survey_info(single_section_p) is $survey_info(single_section_p)"
    if {$survey_info(single_section_p)=="f"} {
	# compress to single section
	db_1row block_sections ""
	if {$num_blocked > 0} {
	    ad_return_complaint 1 "This survey contains measurement sections, which cannot be compressed"
	    ad_script_abort
	}

	set new_sort_order 1
	db_1row first_section ""
	db_foreach all_questions "" {
	    db_dml move_question ""
	    set new_sort_order [expr $new_sort_order + 1]
	}
	db_dml remove_unused_sections ""
	set return_url "one?[export_url_vars survey_id]"
    } else {
	set return_url "section-edit?section_id=$survey_info(section_id)"
    }
    db_dml survey_sectioned_toggle ""
}
    

db_release_unused_handles
ad_returnredirect $return_url
